<?php

namespace Drupal\token_or;

use Drupal\Core\Utility\Token;

/**
 * Tokens Pre Alter Service.
 */
class TokenOrTokensPreAlter {

  /**
   * Token service.
   *
   * @var \Drupal\Core\Utility\Token
   */
  protected $token;

  /**
   * Constructor.
   */
  public function __construct(Token $token) {
    $this->token = $token;
  }

  /**
   * Performs a tokens pre alter.
   */
  public function tokensPreAlter(&$text, $data, $options) {
    $matches = [];

    preg_match("/\[[^\]]*\]/", $text, $matches);

    foreach ($matches as $match) {
      if (strpos($match, '|') !== FALSE) {
        $match_clean = substr(substr($match, 1), 0, -1);
        $sub_tokens = explode('|', $match_clean);

        $multi_token_matches = [];

        foreach ($sub_tokens as $sub_token) {
          if (substr($sub_token, 0, 1) === '"' && substr($sub_token, -1, 1) === '"') {
            // This is a string replacement.
            $result = substr(substr($sub_token, 1), 0, -1);
          }
          else {
            // This is a token replacement.
            $result = \Drupal::token()->replace('[' . $sub_token . ']', $data, $options);
          }
          if ($result) {
            $multi_token_matches[] = $result;
          }
        }

        if (count($multi_token_matches)) {
          $text = str_replace($match, $multi_token_matches[0], $text);
        }
      }
    }
  }

}
